import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { Client, SearchResponse, PingParams } from 'elasticsearch';

@Injectable()
export class ElasticSearchService {
    private _client: Client;

    constructor() {
        if (!this._client) {
          this._connect();
        }
    }

    private _connect() {
        this._client = new Client({
            host: 'http://localhost:9200',
            log: 'trace'
        });
    }

    search(value): any {
        if (value) {
            console.log(value);
            return this._client.search({
                index: 'blog',
                q: `title:${value}`
            });
        } else {
            return Promise.resolve({});
        }
    }

    addToIndex(value): any {
        return this._client.create(value);
    }

    isAvailable(): any {
        const pp: PingParams = {
            requestTimeout: Infinity,
            body: 'Hello elasticsearch!'
        };

        return this._client.ping(pp);
    }
}
